﻿--- This manages options, databases, etc.
local Broker_H3NT = LibStub("AceAddon-3.0"):NewAddon("H3 Nametoggle",
											'AceTimer-3.0')

--- This manages all LDB related things.
local H3NT_Object = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_H3Nametoggle", {type = "data source", icon = select(10, GetAchievementInfo(964)), label = "H3 Nametoggle"})

--- This will be used incase we need something to update constantly without anything disabling/enabling it.
local H3NT = CreateFrame("Frame", "Broker_H3Nametoggle")

--- Used to manage tooltip toggling
local H3NT_2 = CreateFrame("Frame", "Broker_H3Nametoggle")

--- Obviously not the database. >.>
local db -- divisor dividend modulusRemainder eightbitNum redNum greenNum blueNum

--- databases and locales
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale("Broker_H3Nametoggle")
local LibQTip = LibStub("LibQTip-1.0")
local dewdrop   = AceLibrary("Dewdrop-2.0")

--- Local Variables
local totaltime2, elapsed2, elapsed, elap = 0, 0, 0, 0
local TOTALTIME = 5
local tooltip

-------------------
 --- Functions ---
-------------------

-- This is a very useful code snippet I found on WoWWiki's, you guessed it,
-- code snippet section that takes a decimal percent and several rgb values and creates a color.
local function ColorGradient(perc, ...)
if perc then
	if perc >= 1 then
		local r, g, b = select(select('#', ...) - 2, ...)
		return r, g, b
	elseif perc <= 0 then
		local r, g, b = ...
		return r, g, b
	end

	local num = select('#', ...) / 3

	local segment, relperc = math.modf(perc*(num-1))
	local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, ...)

	return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end
return 0, 0, 0
end

--------------
 --- Hooks ---
--------------
--When our broker module is enabled--
function Broker_H3NT:OnEnable()
	self.db = LibStub("AceDB-3.0"):New("Broker_H3NametoggleDB", { profile = {
		iconOnly = false,
		textSize = 17,
	}}, "Default")

function H3NT_ToggleCVar(var,displayname)
	if GetCVar(var) == "1" then
	SetCVar(var, 0)
	print(string.format("|cff%02x%02x%02x%s|r %s is now toggled |cff%02x%02x%02x%s",130,130,200,"H3NameToggle",displayname,255,50,50,"off"))
	else
	SetCVar(var, 1)
	print(string.format("|cff%02x%02x%02x%s|r %s is now toggled |cff%02x%02x%02x%s",130,130,200,"H3NameToggle",displayname,50,255,50,"on"))
	end
	dewdrop:Refresh()
end


function H3NT_GetToggleString(var,displayname)
if GetCVarBool(var) == "1" or GetCVarBool(var) == 1 or GetCVarBool(var) == true then
return string.format("|cff%02x%02x%02x%s",50,255,50,displayname)
else
return string.format("|cff%02x%02x%02x%s",255,50,50,displayname)
end
end
	--Define database related variables for first-time users.
	db = self.db.profile
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_H3Nametoggle", {
		name = "Broker H3 Nametoggle", type = "group",
		get = function(key) return db[key.arg] end,
		set = function(key, value) db[key.arg] = value end,
		args = {
			header1 = { name = "Basic Options", type = "header", order = 1 },
			iconOnly = {
				name = "Icon Only",
				type = "toggle", order = 2, arg = "iconOnly", width = 'full',
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value
					if value then
					H3NT_Object.text = ""
					else
					H3NT_Object.text = "H3 Nametoggle"
					end
				end
			},
			header2 = { name = "Size Options", type = "header", order = 3 },
			textSize = {
				name = "Text Size",
				type = "range", order = 6,  min = 5, max = 30, bigStep = 1, arg = "textSize", width = 'full',
				},

				--Functions for testing purposes. Should never be enabled on official builds.
			--[[
			DEBUGFUNC2 = {
				name = "TEST DATA",
				type = "execute", order = 28, func = function()




				end,
				},
			]]

		},
	})

	--Add to blizzard options for those tho don't want the standalone config for some reason--
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_H3Nametoggle", "Broker H3 Nametoggle")

	--Create our standalone configuration using the config made above.
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("Broker_H3Nametoggle", 400, 200)

	--Create slash commands to open the standalone config
	_G.SlashCmdList["H3NT"] = function() LibStub("AceConfigDialog-3.0"):Open("Broker_H3Nametoggle") end
	_G["SLASH_H3NT1"] = "/brokerH3NT"
	_G["SLASH_H3NT2"] = "/H3Nametoggle"
	_G["SLASH_H3NT3"] = "/H3NT"

end



---Upon entering the module's object on the broker bar---
function H3NT_Object.OnEnter(self)
--Horde Symbol
--select(10, GetAchievementInfo(2788))

--Alliance Symbol
--select(10, GetAchievementInfo(2782))

--Arena Symbol
--select(10, GetAchievementInfo(1174))
   dewdrop:Open(self,
    "children", function()
	--amountnameStr = string.format("|cff%02x%02x%02x%d|r |cff%02x%02x%02x(%s)|r",db.countCol1[1]*255,db.countCol1[2]*255,db.countCol1[3]*255,count,db.nameCol1[1]*255,db.nameCol1[2]*255,db.nameCol1[3]*255,name)
		---Player Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameOwn","Own Name"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameOwn","Own Name") end
			)
	dewdrop:AddSeparator()

		---Player Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameNonCombatCreatureName","Vanity Pets/Critters"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameNonCombatCreatureName","Vanity Pets/Critters") end
			)
	dewdrop:AddSeparator()


		---Player Guilds---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNamePlayerGuild","Guilds"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNamePlayerGuild","Guilds") end
			)

		---Player Titles---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNamePlayerPVPTitle","Titles"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNamePlayerPVPTitle","Titles") end
			)

	dewdrop:AddSeparator()
		---Friendly Player Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameFriendlyPlayerName","Friendly Player Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameFriendlyPlayerName","Friendly Player Names") end
			)

		---Friendly Pet Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameFriendlyPetName","Friendly Pet Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameFriendlyPetName","Friendly Pet Names") end
			)

		---Friendly Guardian Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameFriendlyGuardianName","Friendly Guardian Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameFriendlyGuardianName","Friendly Guardian Names") end
			)

		---Friendly Totem Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameFriendlyTotemName","Friendly Totem Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameFriendlyTotemName","Friendly Totem Names") end
			)

	dewdrop:AddSeparator()
		---Enemy Player Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameEnemyPlayerName","Enemy Player Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameEnemyPlayerName","Enemy Player Names") end
			)

		---Enemy Pet Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameEnemyPetName","Enemy Pet Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameEnemyPetName","Enemy Pet Names") end
			)

		---Enemy Guardian Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameEnemyGuardianName","Enemy Guardian Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameEnemyGuardianName","Enemy Guardian Names") end
			)

		---Enemy Totem Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameEnemyTotemName","Enemy Totem Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameEnemyTotemName","Enemy Totem Names") end
			)

	dewdrop:AddSeparator()
		---NPC Names---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("UnitNameNPC","NPC Names"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("UnitNameNPC","NPC Names") end
			)
	dewdrop:AddSeparator()

			---Allow Overlapping---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("nameplateAllowOverlap","Nameplate Overlapping"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("nameplateAllowOverlap","Nameplate Overlapping") end
			)

			---Friendly Nameplates---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("nameplateShowFriends","Friendly Nameplates"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("nameplateShowFriends","Friendly Nameplates") end
			)

		---Enemy Nameplates---
	dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', H3NT_GetToggleString("nameplateShowEnemies","Enemy Nameplates"),
			'textHeight', db.textSize,
			'notCheckable', true,
			'func', function() H3NT_ToggleCVar("nameplateShowEnemies","Enemy Nameplates") end
			)


		--[[
     dewdrop:AddLine(
			--'icon', select(10, GetItemInfo(49426)),
            'text', "132 (Emblem of Frost)",
			'icon', select(10, GetItemInfo(49426)),
			'textHeight', db.textSize,
			'iconWidth', 15,
			'iconHeight', 15
	)
	]]
    end,
    "point", function()
     if self:GetTop() > GetScreenHeight() / 2 then
      local x = self:GetCenter()
      if x < GetScreenWidth() / 3 then
       return "TOPLEFT", "BOTTOMLEFT"
      elseif x < GetScreenWidth() * 2 / 3 then
       return "TOP", "BOTTOM"
      else
       return "TOPRIGHT", "BOTTOMRIGHT"
      end
     else
      local x = self:GetCenter()
      if x < GetScreenWidth() / 3 then
       return "BOTTOMLEFT", "TOPLEFT"
      elseif x < GetScreenWidth() * 2 / 3 then
       return "BOTTOM", "TOP"
      else
       return "BOTTOMRIGHT", "TOPRIGHT"
      end
     end
    end
   )
end

--[[
Hide the tooltip when we leave it (after half a second)--
function H3NT_Object.OnLeave(self)
	dewdrop:Close(self)
end
]]

--Update variables that need to be updated every "TOTALTIME" seconds (in this case, 5).
H3NT:SetScript('OnUpdate', function(self, elap)
	elapsed = elapsed + elap
if elapsed < TOTALTIME then return end
if db.iconOnly == true then
H3NT_Object.text = ""
else
H3NT_Object.text = "H3 Nametoggle"
end
end)


--Open the options menu or do other things when we click the object.
function H3NT_Object.OnClick(self, button)
if button == "LeftButton" then

--Use AceConfig's 'standalone' menu.
LibStub("AceConfigDialog-3.0"):Open("Broker_H3Nametoggle")
end
end


